
import 'dart:convert';
import 'package:crud_service/crud_service.dart';
import 'package:dio/dio.dart';
import 'package:crud_service/Model/RequestC.dart';
import 'package:crud_service/Model/RequestD.dart';
import 'package:crud_service/Env/ServiceConfig.dart';
import 'package:crud_service/Model/crud_entity.dart';
import 'package:crud_service/Model/request_entity.dart';

class BaseService<T extends CrudEntity> {
  static Dio dio = new Dio(BaseOptions(baseUrl: ServiceConfig.shared.baseUrl()));
  static JsonCodec json = const JsonCodec();
  RequestPage responsePage;

  Future<dynamic> post(String path, RequestEntity data) async {
    var r = await BaseService.dio.post(path, data: data.toJson());
    var responseData = r.data;
    if (responseData is String) {
      print(responseData);
      Map<String, dynamic> jsonData = json.decode(responseData);
      var resultJson = jsonData["result"];
      deserilizerPage(jsonData);
      return resultJson;
    } else {
      print(responseData.toString());
      var resultJson = responseData["result"];
      deserilizerPage(responseData);
      return resultJson;
    }
  }

  void deserilizerPage(Map<String, dynamic> jsonData) {
    if (jsonData["page"] != null && jsonData["page"] is Map<String, dynamic>) {
      responsePage = RequestPage.deserilizer(jsonData["page"]);
    }
  }

  Future<RequestEntity> createRequest() async {
    var request = RequestEntity();

    var requestD = RequestD();
    request.d = requestD;

    List<RequestC> cArray = new List<RequestC>();
    var parameter = ServiceConfig.shared.commonParameter;
    for (String key in parameter.keys) {
      var value = parameter[key];
      cArray.add(RequestC(key, value));
    }
    requestD.c = cArray;
    return request;
  }
}